read <- function(fileName, separators) {
  data <- readLines(con <- file(fileName))
  close(con)
  records <- sapply(data, strsplit, split=separators)
  dataFrame <- data.frame(t(sapply(records,c)))
  rownames(dataFrame) <- 1: nrow(dataFrame)
  return(as.data.frame(dataFrame,stringsAsFactors = FALSE))
}


movies_ml1M <- read("movies.dat", "::")
colnames(movies_ml1M) <- c("Id", "Name", "Genres")
movies_ml1M$Id <- as.integer(movies_ml1M$Id)

ratings <- read.table("ratings.dat", header = FALSE, sep=";")
colnames(ratings) <- c("UID", "OID", "Rating", "Timestamp")

users <- c(1:50)
ratings <- ratings[which(ratings$UID %in% users),]
movieStats <- as.data.frame(table(ratings$OID))

m <- merge(movies_ml1M, movieStats, by.x = "Id",by.y = "Var1", all=FALSE)
movies <- m[which(m$Freq>15),]
ratings <- ratings[which(ratings$OID %in% movies$Id),]

hidden <- ratings[c(1:10),]
train <- ratings[c(11:nrow(ratings)),]

print(data.frame(hidden$UID,hidden$OID))






library(lsa)
cosineSim<- function(x, uid1){
  if(x==uid1){
    0
  }else{
    f1 <- train[which(train$UID==uid1),]
    f2 <- train[which(train$UID==x),] 
    if(nrow(f1)>0 & nrow(f2)>0){
      v <- merge(f1, f2, by.x = "OID",by.y = "OID", all=TRUE)
      v$Rating.x[is.na(v$Rating.x)] <- 0
      v$Rating.y[is.na(v$Rating.y)] <- 0
      c <- cosine(v$Rating.x, v$Rating.y)
    }else{
      c <- matrix(c(0))
    }
    as.numeric(c[1,1])
  }  
}

uid1 <- 1
similarity_row <- lapply(unique(ratings$UID), cosineSim, uid1)
unlist(similarity_row)
